EasyForm (base API)
Date: 2019-04-05

com.twosigma.beakerx.easyform

## Class EasyForm

- java.lang.Object
- - java.util.Observable
  - - com.twosigma.beakerx.easyform.ObservableMap<java.lang.String,java.lang.Object>
    - - com.twosigma.beakerx.easyform.EasyForm

- All Implemented Interfaces:
    com.twosigma.beakerx.widget.DisplayableWidget, com.twosigma.beakerx.widget.WidgetItem, java.util.Map<java.lang.String,java.lang.Object>

      public class EasyForm
      extends ObservableMap<java.lang.String,java.lang.Object>
      implements com.twosigma.beakerx.widget.DisplayableWidget, com.twosigma.beakerx.widget.WidgetItem

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `java.util.Map.Entry<K,V>`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.Integer` | `HORIZONTAL`
    `static java.lang.Integer` | `VERTICAL`

    - ### Fields inherited from class com.twosigma.beakerx.easyform.ObservableMap

      `mapInstance`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EasyForm(java.lang.String caption)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ButtonComponentWidget` | `addButton(java.lang.String label)`
    `ButtonComponentWidget` | `addButton(java.lang.String label, java.lang.String actionCellTag)`
    `EasyFormComponent` | `addCheckBox(java.lang.String label)`
    `EasyFormComponent` | `addCheckBox(java.lang.String label, java.lang.Boolean value)`
    `EasyFormComponent` | `addCheckBoxes(java.lang.String label, java.util.Collection<java.lang.String> values)`
    `EasyFormComponent` | `addCheckBoxes(java.lang.String label, java.util.Collection<java.lang.String> values, java.lang.Integer orientation)`
    `EasyFormComponent` | `addComboBox(java.lang.String label, java.util.Collection<java.lang.String> values)`
    `EasyFormComponent` | `addComboBox(java.lang.String label, java.util.Collection<java.lang.String> values, java.lang.Boolean editable)`
    `EasyFormComponent` | `addComboBox(java.lang.String label, java.util.Collection<java.lang.String> values, java.lang.Boolean editable, java.lang.Integer size)`
    `DatePickerComponentWidget` | `addDatePicker(java.lang.String label)`
    `EasyFormComponent` | `addList(java.lang.String label, java.util.Collection<java.lang.String> values)`
    `EasyFormComponent` | `addList(java.lang.String label, java.util.Collection<java.lang.String> values, java.lang.Boolean multipleSelection)`
    `EasyFormComponent` | `addList(java.lang.String label, java.util.Collection<java.lang.String> values, java.lang.Boolean multipleSelection, java.lang.Integer size)`
    `EasyFormComponent` | `addList(java.lang.String label, java.util.Collection<java.lang.String> values, java.lang.Integer size)`
    `void` | `addLoadValuesButton(java.lang.String path)`
    `EasyFormComponent` | `addPasswordField(java.lang.String label)`
    `EasyFormComponent` | `addPasswordField(java.lang.String label, int size)`
    `EasyFormComponent` | `addRadioButtons(java.lang.String label, java.util.Collection<java.lang.String> values)`
    `EasyFormComponent` | `addRadioButtons(java.lang.String label, java.util.Collection<java.lang.String> values, java.lang.Integer orientation)`
    `void` | `addSaveValuesButton(java.lang.String path)`
    `EasyFormComponent` | `addTextArea(java.lang.String label)`
    `EasyFormComponent` | `addTextArea(java.lang.String label, java.lang.Integer cols, java.lang.Integer rows)`
    `EasyFormComponent` | `addTextArea(java.lang.String label, java.lang.String initialValue)`
    `EasyFormComponent` | `addTextArea(java.lang.String label, java.lang.String initialValue, java.lang.Integer cols, java.lang.Integer rows)`
    `EasyFormComponent` | `addTextField(java.lang.String label)`
    `EasyFormComponent` | `addTextField(java.lang.String label, java.lang.Integer size)`
    `EasyFormComponent<com.twosigma.beakerx.widget.ValueWidget<?>>` | `addWidget(java.lang.String label, com.twosigma.beakerx.widget.ValueWidget<?> widget)`
    `com.twosigma.beakerx.widget.Widget` | `asWidget()`
    `void` | `display()`
    `java.lang.Object` | `get(java.lang.Object key)`
    `java.lang.String` | `getCaption()`
    `java.util.List<com.twosigma.beakerx.widget.Widget>` | `getCommFunctionalities()`
    `java.util.Map<java.lang.String,EasyFormComponent<com.twosigma.beakerx.widget.ValueWidget<?>>>` | `getComponentMap()`
    `LoadValuesButton` | `getLoadValuesButton()`
    `SaveValuesButton` | `getSaveValuesButton()`
    `EasyFormView` | `getView()`
    `com.twosigma.beakerx.widget.DOMWidget` | `getWidget(java.lang.String key)`
    `boolean` | `hasComponents()`
    `boolean` | `hasLoadValuesButton()`
    `boolean` | `hasSaveValuesButton()`
    `java.lang.Boolean` | `isReady()`
    `java.lang.String` | `put(java.lang.String key, java.lang.Object value)`
    `void` | `setEnabled(java.lang.String label, java.lang.Boolean enabled)`
    `void` | `setNotReady()`
    `void` | `setReady()`

    - ### Methods inherited from class com.twosigma.beakerx.easyform.ObservableMap

      `clear, containsKey, containsValue, entrySet, isEmpty, keySet, putAll, remove, size, values`

    - ### Methods inherited from class java.util.Observable

      `addObserver, clearChanged, countObservers, deleteObserver, deleteObservers, hasChanged, notifyObservers, notifyObservers, setChanged`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.util.Map

      `compute, computeIfAbsent, computeIfPresent, equals, forEach, getOrDefault, hashCode, merge, putIfAbsent, remove, replace, replace, replaceAll`

- - ### Field Detail

    - #### HORIZONTAL

          public static final java.lang.Integer HORIZONTAL

    - #### VERTICAL

          public static final java.lang.Integer VERTICAL

  - ### Constructor Detail

    - #### EasyForm

          public EasyForm(java.lang.String caption)

  - ### Method Detail

    - #### addSaveValuesButton

          public void addSaveValuesButton(java.lang.String path)

    - #### addLoadValuesButton

          public void addLoadValuesButton(java.lang.String path)

    - #### addTextField

          public EasyFormComponent addTextField(java.lang.String label)
                                         throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addTextField

          public EasyFormComponent addTextField(java.lang.String label,
                                                java.lang.Integer size)
                                         throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addPasswordField

          public EasyFormComponent addPasswordField(java.lang.String label)
                                             throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addPasswordField

          public EasyFormComponent addPasswordField(java.lang.String label,
                                                    int size)
                                             throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addTextArea

          public EasyFormComponent addTextArea(java.lang.String label)
                                        throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addTextArea

          public EasyFormComponent addTextArea(java.lang.String label,
                                               java.lang.Integer cols,
                                               java.lang.Integer rows)
                                        throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addTextArea

          public EasyFormComponent addTextArea(java.lang.String label,
                                               java.lang.String initialValue)
                                        throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addTextArea

          public EasyFormComponent addTextArea(java.lang.String label,
                                               java.lang.String initialValue,
                                               java.lang.Integer cols,
                                               java.lang.Integer rows)
                                        throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addCheckBox

          public EasyFormComponent addCheckBox(java.lang.String label)
                                        throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addCheckBox

          public EasyFormComponent addCheckBox(java.lang.String label,
                                               java.lang.Boolean value)
                                        throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addComboBox

          public EasyFormComponent addComboBox(java.lang.String label,
                                               java.util.Collection<java.lang.String> values)
                                        throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addComboBox

          public EasyFormComponent addComboBox(java.lang.String label,
                                               java.util.Collection<java.lang.String> values,
                                               java.lang.Boolean editable)
                                        throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addComboBox

          public EasyFormComponent addComboBox(java.lang.String label,
                                               java.util.Collection<java.lang.String> values,
                                               java.lang.Boolean editable,
                                               java.lang.Integer size)
                                        throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addList

          public EasyFormComponent addList(java.lang.String label,
                                           java.util.Collection<java.lang.String> values)
                                    throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addList

          public EasyFormComponent addList(java.lang.String label,
                                           java.util.Collection<java.lang.String> values,
                                           java.lang.Boolean multipleSelection)
                                    throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addList

          public EasyFormComponent addList(java.lang.String label,
                                           java.util.Collection<java.lang.String> values,
                                           java.lang.Integer size)
                                    throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addList

          public EasyFormComponent addList(java.lang.String label,
                                           java.util.Collection<java.lang.String> values,
                                           java.lang.Boolean multipleSelection,
                                           java.lang.Integer size)
                                    throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addRadioButtons

          public EasyFormComponent addRadioButtons(java.lang.String label,
                                                   java.util.Collection<java.lang.String> values)
                                            throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addRadioButtons

          public EasyFormComponent addRadioButtons(java.lang.String label,
                                                   java.util.Collection<java.lang.String> values,
                                                   java.lang.Integer orientation)
                                            throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addCheckBoxes

          public EasyFormComponent addCheckBoxes(java.lang.String label,
                                                 java.util.Collection<java.lang.String> values)
                                          throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addCheckBoxes

          public EasyFormComponent addCheckBoxes(java.lang.String label,
                                                 java.util.Collection<java.lang.String> values,
                                                 java.lang.Integer orientation)
                                          throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addDatePicker

          public DatePickerComponentWidget addDatePicker(java.lang.String label)
                                                  throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addButton

          public ButtonComponentWidget addButton(java.lang.String label)
                                          throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addButton

          public ButtonComponentWidget addButton(java.lang.String label,
                                                 java.lang.String actionCellTag)
                                          throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addWidget

          public EasyFormComponent<com.twosigma.beakerx.widget.ValueWidget<?>> addWidget(java.lang.String label,
                                                                                         com.twosigma.beakerx.widget.ValueWidget<?> widget)
                                                                                  throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getComponentMap

          public java.util.Map<java.lang.String,EasyFormComponent<com.twosigma.beakerx.widget.ValueWidget<?>>> getComponentMap()

    - #### getWidget

          public com.twosigma.beakerx.widget.DOMWidget getWidget(java.lang.String key)

    - #### getCommFunctionalities

          public java.util.List<com.twosigma.beakerx.widget.Widget> getCommFunctionalities()

    - #### hasComponents

          public boolean hasComponents()

    - #### hasSaveValuesButton

          public boolean hasSaveValuesButton()

    - #### hasLoadValuesButton

          public boolean hasLoadValuesButton()

    - #### getSaveValuesButton

          public SaveValuesButton getSaveValuesButton()

    - #### getLoadValuesButton

          public LoadValuesButton getLoadValuesButton()

    - #### getCaption

          public java.lang.String getCaption()

    - #### get

          public java.lang.Object get(java.lang.Object key)

      Specified by:
        `get` in interface `java.util.Map<java.lang.String,java.lang.Object>`
      Overrides:
        `get` in class `ObservableMap<java.lang.String,java.lang.Object>`

    - #### put

          public java.lang.String put(java.lang.String key,
                                      java.lang.Object value)

      Specified by:
        `put` in interface `java.util.Map<java.lang.String,java.lang.Object>`
      Overrides:
        `put` in class `ObservableMap<java.lang.String,java.lang.Object>`

    - #### setEnabled

          public void setEnabled(java.lang.String label,
                                 java.lang.Boolean enabled)

    - #### isReady

          public java.lang.Boolean isReady()

    - #### setReady

          public void setReady()

    - #### setNotReady

          public void setNotReady()

    - #### getView

          public EasyFormView getView()

    - #### display

          public void display()

      Specified by:
        `display` in interface `com.twosigma.beakerx.widget.DisplayableWidget`

    - #### asWidget

          public com.twosigma.beakerx.widget.Widget asWidget()

      Specified by:
        `asWidget` in interface `com.twosigma.beakerx.widget.WidgetItem`